SystemOrganization addCategory: #'Practica2Test-Ejercicio1'!
SystemOrganization addCategory: #'Practica2Test-Ejercicio2'!
SystemOrganization addCategory: #Practica2Test!

Object subclass: #FabricaEmpleados
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2Test-Ejercicio1'!

!FabricaEmpleados methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 00:28'!
EP1
	| ep1 |
	ep1 := EmpleadoPermanente new.
	ep1
		nombre: 'Betiana Rocha';
		direccion: 'Alcorta 1500';
		estadoCivil: 'Casada';
		fechaNacimiento: (Date year: 1979 month: 10 day: 23);
		sueldoBasico: 8000;
		cantidadHijos: 2;
		antiguedad: 5.
	^ ep1! !

!FabricaEmpleados methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 00:28'!
EP2
	| ep2 |
	ep2 := EmpleadoPermanente new.
	ep2
		nombre: 'Cristian Cemero';
		direccion: 'Sabatini 640';
		estadoCivil: 'Soltero';
		fechaNacimiento: (Date year: 1982 month: 9 day: 14);
		sueldoBasico: 6000;
		cantidadHijos: 0;
		antiguedad: 3.
	^ ep2! !

!FabricaEmpleados methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 00:29'!
ET1
	| et1 |
	et1 := EmpleadoTemporario new.
	et1
		nombre: 'Laura Pozzi';
		direccion: 'Sucre 250';
		estadoCivil: 'Soltera';
		fechaNacimiento: (Date year: 1980 month: 5 day: 14);
		sueldoBasico: 4000;
		finContrato: (Date year: 2014 month: 1 day: 1);
		cantidadHorasExtra: 12.
	^ et1! !

!FabricaEmpleados methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 00:29'!
ET2
	| et2 |
	et2 := EmpleadoTemporario new.
	et2
		nombre: 'Juan Jos Lopez';
		direccion: 'Sarmiento 2450';
		estadoCivil: 'Casado';
		fechaNacimiento: (Date year: 1950 month: 12 day: 20);
		sueldoBasico: 9000;
		finContrato: (Date year: 2014 month: 1 day: 1);
		cantidadHorasExtra: 0.
	^ et2! !

TestCase subclass: #EmpleadoPermanenteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2Test-Ejercicio1'!

!EmpleadoPermanenteTest methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/14/2012 00:19'!
testSueldoNetoPermanente
	"Calcula el sueldo Neto del empleado permanente"

	| fabrica ep1  sueldoNetoPermanente |
	fabrica := FabricaEmpleados new.
	ep1:= fabrica EP1.
	sueldoNetoPermanente :=  ep1 calcularSueldoNeto .
	self assert: sueldoNetoPermanente = 6447.5! !

TestCase subclass: #EmpleadoTemporarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2Test-Ejercicio1'!

!EmpleadoTemporarioTest methodsFor: 'as yet unclassified' stamp: 'Olga LucÃÂÃÂ­a Sarmiento 6/14/2012 00:09'!
testSueldoNetoEmpleadoPermanente
	"Se crea un empleado de planta temporaria (ET1), se le pide que calcule su sueldo neto y se chequea que el valor devuelto sea         el esperado. (3524)"

	| fabrica ep1   sueldoBruto totalRetenciones   sueldoNetoPermanente |
	fabrica := FabricaEmpleados new.
	ep1:= fabrica ET1.
	sueldoBruto := ep1 calcularSueldoBruto.
	totalRetenciones := ep1 calcularTotalRetenciones. 
	sueldoNetoPermanente :=  ep1 calcularSueldoNeto.. 
	sueldoNetoPermanente := sueldoBruto - totalRetenciones.
	self assert: sueldoNetoPermanente = 3524! !

TestCase subclass: #EmpresaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2Test-Ejercicio1'!

!EmpresaTest methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/13/2012 21:02'!
setUp

	! !

!EmpresaTest methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 19:01'!
testLiquidarSueldos
	"se crean dos empleados de planta permanente (EP1, EP2), dos empleados de planta temporaria (ET1, ET2) y se los agrega a la empresa; se pide a la empresa que realice la liquidacin de sueldos; se le pide a la empresa los Recibos de Sueldos generados y se chequea que la sumatoria de los sueldosNetos de los Recibos de Sueldos sea la esperada"

	| fabrica ep1 ep2 et1 et2 empresa totalSueldosNetosRecibos |
	fabrica := FabricaEmpleados new.
	ep1 := fabrica EP1.
	ep2 := fabrica EP2.
	et1 := fabrica ET1.
	et2 := fabrica ET2.
	empresa := Empresa new.
	empresa
		addEmpleado: ep1;
		addEmpleado: ep2;
		addEmpleado: et1;
		addEmpleado: et2.
	totalSueldosNetosRecibos := 0.
	empresa realizarLiquidacionSueldos.
	Transcript clear.
	empresa recibos
		do: [ :recibo | 
			totalSueldosNetosRecibos := totalSueldosNetosRecibos + recibo sueldoNeto.
			Transcript show: recibo ].
	self assert: totalSueldosNetosRecibos = 21759! !

!EmpresaTest methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 00:12'!
testTotalRetenciones
	"se crean dos empleados de planta permanente (EP1, EP2), dos empleados de planta temporaria 
	(ET1, ET2) y se los agrega a la empresa; se pide a la empresa que calcule el total de 
	retenciones y se chequea que el valor devuelto sea el	 esperado"

	| fabrica ep1 ep2 et1 et2 empresa totalRetenciones |
	fabrica := FabricaEmpleados new.
	ep1 := fabrica EP1.
	ep2 := fabrica EP2.
	et1 := fabrica ET1.
	et2 := fabrica ET2.
	empresa := Empresa new.
	empresa
		addEmpleado: ep1;
		addEmpleado: ep2;
		addEmpleado: et1;
		addEmpleado: et2.
	totalRetenciones := empresa calcularTotalRetenciones.
	self assert: totalRetenciones = 6521! !

!EmpresaTest methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/13/2012 22:45'!
testTotalSueldosBrutos
	"se crean dos empleados de planta permanente (EP1, EP2), dos empleados de planta temporaria 
	(ET1, ET2) y se los agrega a la empresa; se pide a la empresa que calcule el total de 
	sueldos brutos y se chequea que el valor devuelto sea el	esperado"

	| fabrica ep1 ep2 et1 et2 empresa totalSueldosBrutos |
	fabrica := FabricaEmpleados new.
	ep1 := fabrica EP1.
	ep2 := fabrica EP2.
	et1 := fabrica ET1.
	et2 := fabrica ET2.
	empresa := Empresa new.
	empresa
		addEmpleado: ep1;
		addEmpleado: ep2;
		addEmpleado: et1;
		addEmpleado: et2.
	totalSueldosBrutos := empresa calcularTotalSueldosBrutos.
	self assert: totalSueldosBrutos = 28280! !

!EmpresaTest methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 00:12'!
testTotalSueldosNetos
	"se crean dos empleados de planta permanente (EP1, EP2), dos empleados de planta temporaria 
	(ET1, ET2) y se los agrega a la empresa; se pide a la empresa que calcule el total de 
	sueldos netos y se chequea que el valor devuelto sea el esperado"

	| fabrica ep1 ep2 et1 et2 empresa totalSueldosNetos |
	fabrica := FabricaEmpleados new.
	ep1 := fabrica EP1.
	ep2 := fabrica EP2.
	et1 := fabrica ET1.
	et2 := fabrica ET2.
	empresa := Empresa new.
	empresa
		addEmpleado: ep1;
		addEmpleado: ep2;
		addEmpleado: et1;
		addEmpleado: et2.
	totalSueldosNetos := empresa calcularTotalSueldosNetos.
	self assert: totalSueldosNetos = 21759! !
